character(len=*), parameter :: TAG_SAO_RECORD_LIST          = 'SAORecordList'

!
!=========     S A O    R E C O R D    =========
!
character(len=*), parameter :: TAG_SAO_RECORD               = 'SAORecord'
character(len=*), parameter :: ATTR_FORMAT_VERSION          = 'FormatVersion'
character(len=*), parameter :: ATTR_START_TIME_UTC          = 'StartTimeUTC'
character(len=*), parameter :: UTC_TIME_STANDARD_FORMAT     = 'yyyy-MM-dd -DDD HH:mm:ss.SSS'
character(len=*), parameter :: ATTR_URSI_CODE               = 'URSICode'
character(len=*), parameter :: ATTR_STATION_NAME            = 'StationName'
character(len=*), parameter :: ATTR_GEO_LATITUDE            = 'GeoLatitude'
character(len=*), parameter :: ATTR_GEO_LONGITUDE           = 'GeoLongitude'
character(len=*), parameter :: ATTR_SOURCE                  = 'Source'
character(len=*), parameter :: ATTR_SOURCE_TYPE             = 'SourceType'
character(len=*), parameter :: ATTR_SCALER_TYPE             = 'ScalerType'
!
!---    G E N E R I C S  
!
character(len=*), parameter :: TAG_NAME                     = 'Name'
character(len=*), parameter :: ATTR_NAME                    = 'Name'
character(len=*), parameter :: ATTR_NUM                     = 'Num'
character(len=*), parameter :: ATTR_VERSION                 = 'Version'
character(len=*), parameter :: ATTR_UNITS                   = 'Units'
character(len=*), parameter :: ATTR_STEP                    = 'Step'
character(len=*), parameter :: ATTR_FORMAT                  = 'Format'
character(len=*), parameter :: ATTR_VAL                     = 'Val'
character(len=*), parameter :: ATTR_FLAG                    = 'Flag'
character(len=*), parameter :: ATTR_DESCRIPTION             = 'Description'
character(len=*), parameter :: ATTR_SIG_FIG                 = 'SigFig'
character(len=*), parameter :: ATTR_NO_VALUE                = 'NoValue'
character(len=*), parameter :: ATTR_ID                      = 'ID'
character(len=*), parameter :: ATTR_MODEL                   = 'Model'
character(len=*), parameter :: ATTR_MODEL_NAME              = 'ModelName'
character(len=*), parameter :: ATTR_MODEL_OPTIONS           = 'ModelOptions'
character(len=*), parameter :: ATTR_ALTITUDE                = 'Altitude'
character(len=*), parameter :: ATTR_STATUS                  = 'Status'
!
!---     U N C E R T A I N T Y    B O U N D S
!
character(len=*), parameter :: TAG_BOUND_LIST               = 'BoundList'
character(len=*), parameter :: TAG_UPPER_BOUND_LIST         = 'UpperBoundList'
character(len=*), parameter :: TAG_LOWER_BOUND_LIST         = 'LowerBoundList'
character(len=*), parameter :: ATTR_BOUND                   = 'Bound'
character(len=*), parameter :: ATTR_UPPER_BOUND             = 'UpperBound'
character(len=*), parameter :: ATTR_LOWER_BOUND             = 'LowerBound'
character(len=*), parameter :: ATTR_BOUNDARY_TYPE           = 'BoundaryType'
!
!---    (1)   S Y S T E M   I N F O
!
character(len=*), parameter :: TAG_SYSTEM_INFO              = 'SystemInfo'
character(len=*), parameter :: ATTR_UML_STATION_ID          = 'UMLStationID'
character(len=*), parameter :: TAG_FREQUENCY_STEPPING       = 'FrequencyStepping'
character(len=*), parameter :: ATTR_START_FREQUENCY         = 'StartFrequency'
character(len=*), parameter :: ATTR_STOP_FREQUENCY          = 'StopFrequency'
character(len=*), parameter :: TAG_LINEAR_STEPPING          = 'LinearStepping'
character(len=*), parameter :: TAG_LOG_STEPPING             = 'LogStepping'
character(len=*), parameter :: TAG_TABULATED_STEPPING       = 'TabulatedStepping'
character(len=*), parameter :: TAG_RESTRICTED_FREQUENCY_LIST= 'RestrictedFrequencyList'
character(len=*), parameter :: TAG_LOWER_LIMIT_LIST         = 'LowerLimitList'
character(len=*), parameter :: TAG_UPPER_LIMIT_LIST         = 'UpperLimitList'
character(len=*), parameter :: TAG_RANGE_STEPPING           = 'RangeStepping'
character(len=*), parameter :: ATTR_START_RANGE             = 'StartRange'
character(len=*), parameter :: ATTR_STOP_RANGE              = 'StopRange'
character(len=*), parameter :: TAG_AUTO_SCALER              = 'AutoScaler'
character(len=*), parameter :: ATTR_ARTIST_FLAGS            = 'ArtistFlags'
character(len=*), parameter :: TAG_MANUAL_SCALER            = 'ManualScaler'
character(len=*), parameter :: TAG_COMMENTS                 = 'Comments'
character(len=*), parameter :: TAG_START_TIME               = 'StartTime'
character(len=*), parameter :: ATTR_TIME_ZONE               = 'TimeZone'
character(len=*), parameter :: TAG_CONTACT_PERSON           = 'ContactPerson'
character(len=*), parameter :: TAG_AFFILIATION              = 'Affiliation'
character(len=*), parameter :: TAG_ADDRESS                  = 'Address'
character(len=*), parameter :: TAG_EMAIL                    = 'Email'
character(len=*), parameter :: TAG_SOLAR_TERRESTRIAL_DATA   = 'SolarTerrestrialData'
character(len=*), parameter :: TAG_GYROFREQUENCY            = 'GyroFrequency'
character(len=*), parameter :: TAG_DIP_ANGLE                = 'DipAngle'
character(len=*), parameter :: TAG_KP                       = 'Kp'
character(len=*), parameter :: TAG_SUNSPOT_NUMBER           = 'SunSpotNumber'
character(len=*), parameter :: TAG_F107                     = 'F107'
character(len=*), parameter :: TAG_DIGISONDE_PREFACE        = 'DigisondePreface'
!
!---    (2)   C H A R A C T E R I S T I C   L I S T
!
character(len=*), parameter :: TAG_CHARACTERISTIC_LIST      = 'CharacteristicList'
character(len=*), parameter :: TAG_URSI                     = 'URSI'
character(len=*), parameter :: TAG_MODELED                  = 'Modeled'
character(len=*), parameter :: TAG_CUSTOM                   = 'Custom'
character(len=*), parameter :: ATTR_QL                      = 'QL'
character(len=*), parameter :: ATTR_DL                      = 'DL'
!
!---    (3)   T R A C E   L I S T
!
character(len=*), parameter :: TAG_TRACE_LIST               = 'TraceList'
character(len=*), parameter :: TAG_TRACE                    = 'Trace'
character(len=*), parameter :: ATTR_TYPE                    = 'Type'
character(len=*), parameter :: ATTR_LAYER                   = 'Layer'
character(len=*), parameter :: ATTR_MULTIPLE                = 'Multiple'
character(len=*), parameter :: ATTR_POLARIZATION            = 'Polarization'
character(len=*), parameter :: TAG_FREQUENCY_LIST           = 'FrequencyList'
character(len=*), parameter :: TAG_RANGE_LIST               = 'RangeList'
character(len=*), parameter :: TAG_TRACE_VALUE_LIST         = 'TraceValueList'

!
!---    (4)   P R O F I L E   L I S T
!
character(len=*), parameter :: TAG_PROFILE_LIST             = 'ProfileList'
character(len=*), parameter :: TAG_PROFILE                  = 'Profile'
character(len=*), parameter :: ATTR_ALGORITHM               = 'Algorithm'
character(len=*), parameter :: ATTR_ALGORITHM_VERSION       = 'AlgorithmVersion'
character(len=*), parameter :: TAG_ALGORITHM_OPTIONS        = 'AlgorithmOptions'
character(len=*), parameter :: TAG_TABULATED                = 'Tabulated'
character(len=*), parameter :: TAG_ALTITUDE_LIST            = 'AltitudeList'
character(len=*), parameter :: TAG_PROFILE_VALUE_LIST       = 'ProfileValueList'
character(len=*), parameter :: TAG_SHIFTED_CHEBYSHEV_LIST   = 'ShiftedChebyshevList'
character(len=*), parameter :: TAG_SHIFTED_CHEBYSHEV        = 'ShiftedChebyshev'
character(len=*), parameter :: ATTR_END_FREQUENCY           = 'EndFrequency'
character(len=*), parameter :: ATTR_REGION                  = 'Region'
character(len=*), parameter :: ATTR_PEAK_HEIGHT             = 'PeakHeight'
character(len=*), parameter :: ATTR_ERROR                   = 'Error'
character(len=*), parameter :: ATTR_Z_HALF_NM               = 'zHalfNm'
character(len=*), parameter :: TAG_QUASI_PARABOLIC_LIST     = 'QuasiParabolicList'
character(len=*), parameter :: TAG_QUASI_PARABOLIC          = 'QuasiParabolic'
character(len=*), parameter :: ATTR_EARTH_RADIUS            = 'EarthRadius'
character(len=*), parameter :: ATTR_START_DISTANCE          = 'StartDistance'
character(len=*), parameter :: ATTR_END_DISTANCE            = 'EndDistance'
character(len=*), parameter :: ATTR_A                       = 'A'
character(len=*), parameter :: ATTR_B                       = 'B'
character(len=*), parameter :: ATTR_C                       = 'C'
character(len=*), parameter :: TAG_POLAN_LIST               = 'POLANList'
character(len=*), parameter :: TAG_POLAN                    = 'POLAN'
character(len=*), parameter :: TAG_PROFILE_VALLEY           = 'ProfileValley'
character(len=*), parameter :: ATTR_WIDTH                   = 'Width'
character(len=*), parameter :: ATTR_DEPTH                   = 'Depth'
character(len=*), parameter :: ATTR_START_HEIGHT            = 'StartHeight'
character(len=*), parameter :: TAG_TOPSIDE_CHAPMAN          = 'TopsideChapman'
character(len=*), parameter :: ATTR_PEAK_DENSITY            = 'PeakDensity'
character(len=*), parameter :: ATTR_PEAK_SCALE_HEIGHT       = 'PeakScaleHeight'

!
!---    R E S E R V E D    A T T R I B U T E    V A L U E S
!
! capitalization of the first letter is varying
! typically nouns have first letter capitalized, adjectives - not
!
character(len=*), parameter :: VAL_IONOSONDE        = 'Ionosonde'
character(len=*), parameter :: VAL_MODEL            = 'Model'
character(len=*), parameter :: VAL_ARP              = 'ARP'
character(len=*), parameter :: VAL_MANUAL           = 'manual'
character(len=*), parameter :: VAL_AUTO             = 'auto'
character(len=*), parameter :: VAL_STANDARD         = 'standard'
character(len=*), parameter :: VAL_NONSTANDARD      = 'non-standard'
character(len=*), parameter :: VAL_LAYER_F2         = 'F2'
character(len=*), parameter :: VAL_LAYER_F1         = 'F1'
character(len=*), parameter :: VAL_LAYER_F          = 'F'
character(len=*), parameter :: VAL_LAYER_E          = 'E'
character(len=*), parameter :: VAL_LAYER_ES         = 'ES'
character(len=*), parameter :: VAL_LAYER_EA         = 'EA'
character,parameter         :: VAL_ORDINARY         = 'O'
character,parameter         :: VAL_EXTRAORDINARY    = 'X'
character(len=*), parameter :: VAL_AMPLITUDE        = 'Amplitude'
character(len=*), parameter :: VAL_DOPPLER_SHIFT    = 'DopplerShift'
character(len=*), parameter :: VAL_VERTICAL         = 'vertical'
character(len=*), parameter :: VAL_OFF_VERTICAL     = 'off-vertical'
character(len=*), parameter :: VAL_AVERAGE          = 'average'
character(len=*), parameter :: VAL_AURORAL          = 'auroral'
character(len=*), parameter :: VAL_INTERNAL_BOUND   = 'internal-bound'
character(len=*), parameter :: VAL_EXTERNAL_BOUND   = 'external-bound'
character(len=*), parameter :: VAL_PLASMA_DENSITY   = 'PlasmaDensity'
character(len=*), parameter :: VAL_PLASMA_FREQUENCY = 'PlasmaFrequency'
character(len=*), parameter :: VAL_EDITED           = 'edited'
character(len=*), parameter :: VAL_VALIDATED        = 'validated'
character(len=*), parameter :: VAL_FLOAT            = 'float'
character(len=*), parameter :: VAL_INTEGER          = 'integer'

